#!/bin/sh
#
# Dragon Flame installer
#

# rcupration du rep
cwd=`dirname $0`

NAME="dragonflame"
TARGET_DIR="/usr/local"

PROJECT_FILE="dragonflame.pro"
MAKEFILE=Makefile
QMAKE=qmake
MAKE=make
MAKE_TARGET=""
MAKE_CLEAN=clean
PAGER=less
LICENSE=COPYING
MAKE_OPT="-k -C $cwd -f $cwd/$MAKEFILE"

#--------------------------------
#--------------------------------
echo ""
echo "This will compile and install Dragon Flame 2.0 for GNU/Linux"
echo "Press ENTER to continue and see license... (q when ok)"
read user
user="s"


while [ $user != "y" ]; do
	if [ $user = "s" ]; then
		$PAGER $cwd/$LICENSE
	fi
	
	echo ""
	echo "Do you agree with it ?"
	echo ""
	echo "y(Yes) - Default"
	echo "n(No)"
	echo "s(See again)"
	echo -n ">"
	read user
	if [ -z $user ]; then
		user=y
	fi
	if [ $user = "n" ]; then
		exit
	fi
done

echo ""
echo "Compile?"
echo ""
echo "y(Yes) - Default"
echo "n(No)"
echo "q(Quit)"
echo -n ">"
read user
if [ -z $user ]; then
	user=y
fi

case $user in
	q)
		exit
	;;
	n)
	;;
	*)
		# launch qmake
		$QMAKE -Wall $cwd/$PROJECT_FILE -o $cwd/$MAKEFILE
		
		# make
		echo $MAKE_OPT
		$MAKE $MAKE_OPT $MAKE_TARGET
	;;
esac

echo ""
echo "Clean?"
echo ""
echo "y(Yes) - Default"
echo "n(No)"
echo "q(Quit)"
echo -n ">"
read user
if [ -z $user ]; then
	user=y
fi

case $user in
	q)
		exit
	;;
	n)
	;;
	*)
		# make clean
		$MAKE $MAKE_OPT $MAKE_CLEAN
	;;
esac


user=$TARGET_DIR
echo ""
echo "Install in ...?"
echo ""
echo "($TARGET_DIR)"
echo "nothing - End"
echo -n ">"
read user
if [ -z $user ]; then
	exit
fi

if [ -d $user ] && [ -w $user ]; then
	mkdir -- $user/$NAME
	cp -frv -- $cwd/* $user/$NAME
else
	echo "Invalid directory"
fi
