/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#include "Dico.h"
#include "page.h"

void Dico::connectMyPages()
{
	int end = m_pages.size();
	
	for( int i=0; i<(end-1); ++i )
	{
		m_pages[i]->setVoisin( m_pages[i+1] );
	}
	
	m_pages[end-1]->setVoisin( m_pages[0] );
}

void Dico::connectMyPagesToTheTabWidget( QTabWidget *left )
{
	int end = m_pages.size();
	int i;
	
	for( i=0; i<end; ++i )
	{
		Page *curpage = m_pages[i];
		left->addTab( curpage, curpage->title() );
	}
	
	for( i=0; i<end; ++i )
	{
		Page *curpage = m_pages[i];
		left->removePage( curpage );
	}	
}

/* EOF */
