/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
#include <qapplication.h>
#include "dfstatusbar.h"

DFStatusBar::DFStatusBar( QWidget *parent, const char *name )
	: QStatusBar( parent, name )
{
	setFixedHeight(18);
	
	QLabel *nbwordsetiquette = new QLabel( "ENTRIES", this );
	nbwordsetiquette->setFont( QFont( "Arial", 8 ));
	addWidget( nbwordsetiquette, 0, TRUE );
	
	m_nbwordslab = new QLabel( "", this );
	m_nbwordslab->setFont( QFont( "Arial", 8 ));
	addWidget( m_nbwordslab, 0, TRUE );

	QLabel *updtlab = new QLabel( "UPDT", this );
	updtlab->setFont( QFont( "Arial", 8 ));
	addWidget( updtlab, 0, TRUE );

	m_downloadbar = new DownloadBar( qApp->applicationDirPath()+"/../images/download.png", 24, this );
	addWidget( m_downloadbar, 0 , TRUE );
}

/* EOF */
