/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#ifndef DFSTATUS_H
#define DFSTATUS_H

#include <qstatusbar.h>
#include <qlabel.h>

#include "downloadbar.h"

class DFStatusBar:public QStatusBar
{
  protected:
	DownloadBar *m_downloadbar;
	QLabel* m_nbwordslab;
	
  public:
	DFStatusBar(QWidget * parent = 0, const char * name = 0 );
	void start() {m_downloadbar->start();};
	void stop()  {m_downloadbar->stop();};
	void writeNbWords(int nbwords) {m_nbwordslab->setText(QString("%1").arg(nbwords));};

};

#endif
