/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
#ifndef DICTONLINE_H
#define DICTONLINE_H

#include <qdialog.h>
#include <qtextview.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qvector.h>
#include <qcombobox.h>
#include <qstatusbar.h>
#include "dictProtocol.h"
#include "downloadbar.h"

class DictOnline : public QDialog
{
	Q_OBJECT

  protected:
	QTextView    *view;
	QLineEdit    *line;
	QPushButton  *okbutton;
	DICTClient   *dictionary;
	DownloadBar  *move;
	QComboBox    *combo;
	QStatusBar   *statusbar;

  protected:
	void customEvent( QCustomEvent *e );

  protected slots:
	void search();

  public:
	DictOnline( QString host = "dict.org", QWidget* parent = 0, const char *name=0,WFlags f=0  );

	void define( QString word );
};


#endif
