/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
#include "downloadbar.h"
#include <qapplication.h>

DownloadBar::DownloadBar( QString image, int fps, QWidget* parent, const char *)
	: QLabel( parent )
{
	connect( &count, SIGNAL(timeout()), this, SLOT(progressplusplus()) );
	m_im     = new QImage( image );
//	m_paint  = new QPainter( this );
	m_paint  = new QPainter();
	m_size   = m_im->width()/2;
	m_fps    = fps;
	setFixedWidth( m_size );
	progress = m_size;

    QPixmap pm( m_size, 15 );
	pm.fill( this, 0, 0 );
//    m_paint->begin( &pm );
//    m_paint->drawImage( progress-m_size, 0, *m_im );
//    m_paint->end();
    bitBlt( this, 0, 0, &pm );
}

void DownloadBar::paintEvent( QPaintEvent * )
{
	// Create the pixmap and fill it with the widget's background
    QPixmap pm( m_size, 15 );
	pm.fill( this, 0, 0 );

    // Paint the pixmap. Cool wave effect
    m_paint->begin( &pm );
    m_paint->drawImage( progress-m_size, 0, *m_im );
    m_paint->end();

    // Copy the pixmap into the widget
    bitBlt( this, 0, 0, &pm );
}

void DownloadBar::start()
{
	m_bstop = false;
	count.start( 1000/m_fps );	
}


void DownloadBar::stop()
{
	m_bstop = true;
}

void DownloadBar::progressplusplus()
{
	if( m_bstop == true && progress==m_size-1 )
	{
		count.stop();
	}

	progress++;
	if ( progress >= m_size*2 )
	{
		progress=0;
	}
	repaint( false );
}

/* EOF */
