/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
#ifndef MPG_H
#define MPG_H

#include <qlabel.h>
#include <qtimer.h>
#include <qpainter.h>
#include <qimage.h>

class DownloadBar : public QLabel
{
	Q_OBJECT

protected:
	int progress;
    void paintEvent( QPaintEvent * );
	QTimer count;
	QImage* m_im;
	QPainter* m_paint;
	int m_size;
	int m_fps;
	bool m_bstop;

protected slots:
	void progressplusplus();

public :
	DownloadBar(QString image, int fps, QWidget* parent = 0, const char *name=0 );
	void start();
	void stop();
};


#endif
