/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
#include <qpixmap.h>
#include <qlayout.h>

#include "centralwidget.h"
#include "helpwindow.h"
#include "preferences.h"

HelpWindow::HelpWindow( CentralWidget *ctrlwdg, const QString&, const QString&,
			QWidget* parent, const char *name, WFlags f  )
    : QDialog( parent, name , f | WStyle_Customize | WStyle_NormalBorder | WStyle_Title | WStyle_SysMenu )
{
	QString unifontname = DFConfig::instance()->getString( "fonts", "unicode", "Lucida Sans Unicode" );
	QFont unifont( unifontname, 9 );
	setFont( unifont );

	m_ctrlwdg=ctrlwdg;

	// Layout
	QVBoxLayout *lay = new QVBoxLayout(this);
	// NOTE: la ligne d'aprs dfinit comment les enfants vont tre redimensionns
	//       indispensable sinon, a marche pas trs bien
	lay->setResizeMode(QLayout::FreeResize);

	// HTML component
	browser = new QTextBrowser( this );
	browser->mimeSourceFactory()->setFilePath( qApp->applicationDirPath()+"/../dicos" );
    browser->setFrameStyle( QFrame::Panel | QFrame::Sunken );

	lay->add(browser);

//	if ( !home_.isEmpty() )
//		browser->setSource( "doc/index.html");

	// Layout
	browser->resize( 640,700 );
    resize( 640,700 );

	// Background picture
	QBrush paper;
    paper.setPixmap( QPixmap( qApp->applicationDirPath()+"/../images/tile.png" ) );
    browser->setPaper( paper );
    browser->setFocus();
}

void HelpWindow::showe()
{
	// Current dictionary help
	browser->mimeSourceFactory()->setFilePath(qApp->applicationDirPath()+ "/../dicos" );
  	browser->setSource( m_ctrlwdg->helpfilename() );
	show();
}

void HelpWindow::showd()
{
	// Dragon Flame documentation
	browser->mimeSourceFactory()->setFilePath( qApp->applicationDirPath()+"/../doc" );
  	browser->setSource( "dfdoc.html" );
	show();
}

/* EOF */
