/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

//composant utilis pour la gestion d'une listbox contenant des "entry"
//voir la classe entry
//ie rajout ou retrait d'entres, etc...
//je mets toutes les entres dans un vecteur 
//(sous forme de pointeurs, ce sont des entry * en fait)

#include "listboxmanager.h"
typedef vector<Entry*>::iterator entryIt;

#include <qtextstream.h>

ListBoxManager::ListBoxManager( QListBox *qlistbox )
{
	//un listboxmanager, a se greffe sur une listbox
	m_qlb = qlistbox;
	m_count = 0;
	initMap("abcdefghijklmnopqrstuvwxyz");


}

void ListBoxManager::inserte(Entry *entry)
{
	//fonction qui insre une entre au manager
	int i;
	
	QString toinsert = entry->getName();

	//on parcours le vecteur des entres par ordre alphabtique
	//et quand c'est bon hop
	entryIt it = m_entries.begin();
	for(i=0;it!=m_entries.end()&&toinsert>=(*it)->getName();it++,i++);

	//on insre l'entre, et on la slectionne dans la listbox
	m_qlb->insertItem(toinsert,i);
	m_qlb->setCurrentItem(i);
	entry->setItem(m_qlb->item(m_qlb->currentItem()));
	m_qlb->setTopItem(m_qlb->currentItem());

	m_count++;

	//on insre bien sur l'entry au vecteur des entres
	m_entries.insert(it,entry);
}

void ListBoxManager::insertewoconneries(Entry *entry)
{
	//mme fonction, sauf qu'on fait pas les slections  la fin

	QString toinsert = entry->getName();


//	int i=0;
	entryIt it = m_entries.end();
	int stop=m_entries.size();
	int j=stop;
	
	if(stop==0) {
		m_entries.push_back(entry);
	}
	else 
	{
		j--;
		it--;
		for(int i=0;i<stop&&!supEq(toinsert,(*it)->getName());--it,--j,i++);
		it++;
		j++;
		m_entries.insert(it,entry);
	}
	m_qlb->insertItem(toinsert,j);
	entry->setItem(m_qlb->item(j));

	m_count++;
}

void ListBoxManager::insertefin(Entry *entry)
{
	//mme fonction, sauf qu'on cherche pas : on pute  la fin.

	QString toinsert = entry->getName();

	entryIt it = m_entries.end();
	
	m_qlb->insertItem(toinsert,m_count);
	entry->setItem(m_qlb->item(m_count));
	m_entries.insert(it,entry);

	m_count++;
}

void ListBoxManager::removee(Entry *entry)
{
	//pour virer une entre
	removei(indexof(entry));
	m_count--;
}

void ListBoxManager::removei(int toremove)
{
	//pour virer l'entre numro tant
	m_qlb->removeItem(toremove);

	entryIt it = m_entries.begin();
	for(int i=0;i<toremove;it++,i++);

	m_count--;
//	Entry *etoremove = m_entries[toremove];
	m_entries.erase(it);
//	delete(etoremove);
}

int ListBoxManager::indexof(Entry *entry)
{
	//pour rcuprer l'index de telle entry
	unsigned int i=0;

	while(entry!=m_entries[i]&&i<=m_entries.size()) i++;

	if(i>m_entries.size()) return -1;
	else return i;
}

int ListBoxManager::indexof(QString entryname)
{
	//pour rcuprer l'index de telle entryname
	unsigned int i=0;

	entryIt it=m_entries.begin();

	for(i=0;it!=m_entries.end();++it,++i)
	{
		if(entryname==m_entries[i]->getName()) break;
	}

	if(i==m_entries.size()) return -1;
	else return i;
}

Entry *ListBoxManager::entryAt(int index)
{
	//kekkigna comme entre au numro tant ?
	return m_entries[index];
}

void ListBoxManager::refreshEntry(Entry *entry)
{
	//alors a c'est trs tordu
	//utilis dans le cas o le type change le nom mme de l'entry
	//on la supprime, et hop on la rerajoute (comme a elle est
	//remise au bon endroit, mme si on a cahng son nom)

	int i;
	entryIt it = m_entries.begin();
	for(i=0;it!=m_entries.end()&&m_entries[i]!=entry;it++,i++);

	m_qlb->removeItem(i);
	m_entries.erase(it);

	inserte(entry);
}

void ListBoxManager::menage()
{
	//porte bien son nom :p

	m_count=0;
	m_qlb->clear();

	entryIt it = m_entries.begin();

	int stop = m_entries.size();

	for(int i=0;i<stop;i++)
	{
		m_entries.erase(it);
	}
}

void ListBoxManager::initMap(QString) // remettre
{
	/*
	QTextStream txs(&alphabet,IO_ReadOnly);

	int i=10000;
	QChar buffer;

	while(!txs.atEnd())
	{
		txs>>buffer;
		m_map.insert(buffer,i);
		i++;
	}
*/
	int i=10000;
	//"abcdefghijklmnopqrstuvwxyz"
	m_map.insert(QChar(185),i);m_map.insert(QChar(178),i++);
	m_map.insert('a',i);m_map.insert('',i);m_map.insert('',i);m_map.insert('',i++);
	m_map.insert('b',i++);
	m_map.insert('c',i++);
	m_map.insert('d',i++);
	m_map.insert('e',i);m_map.insert('',i);m_map.insert('',i);m_map.insert('',i++);
	m_map.insert('f',i++);
	m_map.insert('g',i++);
	m_map.insert('h',i++);
	m_map.insert('i',i);m_map.insert('',i);m_map.insert('',i);m_map.insert('',i++);
	m_map.insert('j',i++);
	m_map.insert('k',i++);
	m_map.insert('l',i++);
	m_map.insert('m',i++);
	m_map.insert('n',i);m_map.insert('',i++);
	m_map.insert('o',i);m_map.insert('',i);m_map.insert('',i);m_map.insert('',i);m_map.insert(QChar(339),i++);
	m_map.insert('p',i++);
	m_map.insert('q',i++);
	m_map.insert('r',i++);
	m_map.insert('s',i++);
	m_map.insert('t',i++);
	m_map.insert('u',i);m_map.insert('',i);m_map.insert('',i);m_map.insert('',i++);
	m_map.insert('v',i++);
	m_map.insert('w',i++);
	m_map.insert('x',i++);
	m_map.insert('y',i);m_map.insert('',i);m_map.insert(QChar(375),i++);
	m_map.insert('z',i++);
}

int ListBoxManager::val(QChar c)
{
	if(m_map.contains(c)) return(m_map[c]);
	else return c.latin1();
}

bool ListBoxManager::supEq(QString stri1,QString stri2)
{

	QString str1(stri1.lower());
	QString str2(stri2.lower());

	int i;
	int min;
	int l1=str1.length();
	int l2=str2.length();

	if(l1>=l2) min = l2; else min = l1; 

	for(i=0;i<min;i++)
	{
		if(val(str1[i])>val(str2[i])) return true;
		if(val(str1[i])<val(str2[i])) return false;
	}

	return(l1>=l2);
}

bool ListBoxManager::sup(QString stri1,QString stri2)
{
	QString str1(stri1.lower());
	QString str2(stri2.lower());

	int i;
	int min;
	int l1=str1.length();
	int l2=str2.length();

	if(l1>=l2) min = l2; else min = l1; 

	for(i=0;i<min;i++)
	{
		if(val(str1[i])>val(str2[i])) return true;
		if(val(str1[i])<val(str2[i])) return false;
	}

	return(l1>l2);
}

bool ListBoxManager::startsWith(QString stri1,QString stri2)
{
	QString str1(stri1.lower());
	QString str2(stri2.lower());

	int i;

	int l1=str1.length();
	int l2=str2.length();

	if(l1<l2) return false; 

	for(i=0;i<l2;i++)
	{
		if(val(str1[i])!=val(str2[i])) return false;
	}

	return true;
}

bool ListBoxManager::infEq(QString stri1,QString stri2)
{
	return(!sup(stri1,stri2));
}

bool ListBoxManager::inf(QString stri1,QString stri2)
{
	return(!supEq(stri1,stri2));
}

/* EOF */
