/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
#ifndef LISTBOXMANAGER_H
#define LISTBOXMANAGER_H

#include <qlistbox.h>
#include <vector>
#include "entry.h"

using namespace std;

#include <qmap.h>
typedef QMap<QChar,int> AlphaMap;

class ListBoxManager : public QObject
{

public :
	ListBoxManager(QListBox *qlistbox);
	//~ListBoxManager();
	void inserte(Entry *entry);
	void insertewoconneries(Entry *entry);
	void insertefin(Entry *entry);
	void removei(int toremove);
	int indexof(Entry *entry);
	int indexof(QString entryname);
	void removee(Entry *entry);
	Entry* entryAt(int index);
	void refreshEntry(Entry *entry);
	int count(void) {return m_qlb->count();};
	void menage();

	int val(QChar c);
	bool sup(QString str1,QString str2);
	bool supEq(QString str1,QString str2);
	bool inf(QString str1,QString str2);
	bool infEq(QString str1,QString str2);

	bool startsWith(QString stri1,QString stri2);

	void initMap(QString alphabet);

protected:
	AlphaMap m_map;
	int m_count;
	QListBox *m_qlb;
	vector<Entry *>m_entries;
};

#endif
