/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
#include <qapplication.h>
#include <qdialog.h>
#include <qsound.h>
#include <qmessagebox.h>
#include "mainwindow.h"
#include "splashwindow.h"

int main( int argc, char ** argv )
{
	QApplication * a = new QApplication(argc, argv);
    
#ifndef _DEBUG
	try
#endif
	{
		QSound::play(qApp->applicationDirPath()+ "/../sounds/bdragon1.wav" );
		
		QDialog* dl = new QDialog( NULL );
		dl->hide();

// trop rapide sous linux ?
#ifdef WIN32
#ifndef _DEBUG
		SplashWindow *splash= new SplashWindow( dl );
		splash->show();
#endif
#endif
		MainWindow *mw = new MainWindow();
		a->setMainWidget( mw );
    
		a->connect( a, SIGNAL( lastWindowClosed() ), a, SLOT( quit() ) );
		int result = a->exec();

		delete mw;
		return result;
	}
#ifndef _DEBUG
	catch ( ... )
	{
		QMessageBox::critical( 
			0, 
			"Dragon Flame",
			"<b>Critical error:</b><br/>Ooops!&nbsp;Dragon&nbsp;Flame&nbsp;crashed...",
			"Abort" );
		return( -1 );
	}
#endif
}

/* EOF */
