/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
#ifndef AB_MAINWINDOW_H
#define AB_MAINWINDOW_H

#include <qmainwindow.h>
#include <qstring.h>

#include "httpSynchronizer.h"

class QToolBar;
class QPopupMenu;
class CentralWidget;

class DFStatusBar;
class HelpWindow;
class About;
class QLabel;
class DictOnline;
class SearchInterface;

class MainWindow: public QMainWindow
{
    Q_OBJECT
		
public:
    MainWindow();
	CentralWidget* centralWidget() {return view;};
	SearchInterface* searchInterface() {return m_si;};
	
protected slots:
	void styleCDE();	
    void help();
	void documentation();
	void quit();
	void about();
	void updates();
	void copy();
	void copyTengwar();
	void searchExp();
	void searchDictOnline();

protected:
    void setupMenuBar();
    void setupFileTools();
    void setupStatusBar();
    void setupCentralWidget();
	void closeEvent( QCloseEvent *e );
	void customEvent( QCustomEvent *e );
	
	QFont appFont;
    QToolBar *fileTools;
    QString filename;
    CentralWidget *view;
	HelpWindow* m_hlpw;
	About* m_about;
	QPopupMenu *m_file;
	QPopupMenu *m_help;
	int id_checkUpdates;
	httpSynchronizer m_updates;
	QPopupMenu *m_edit;
	QPopupMenu *m_tools;

	DFStatusBar* m_statusbar;
	DictOnline* m_dictOnline;

	SearchInterface* m_si;
};


#endif
