/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
#include "page.h"
#include "centralwidget.h"

void SearchField::keyPressEvent ( QKeyEvent *ke )
{
	switch( ke->key() )
	{
	  case Key_Up :
		if( m_lb->count() > 0 )
		{
			if( m_lb->currentItem() > 0 )
			{
				m_lb->setSelected( m_lb->currentItem()-1, true );
				m_lb->ensureCurrentVisible();
			}
			break;
		}

	  case Key_Down :
		if(m_lb->count()>0)
		{
			if (m_lb->currentItem() < (signed int)(m_lb->count()-1)) //TODO voir si on ne peut pas caster dans l'autre sens
			{
				m_lb->setSelected( m_lb->currentItem()+1, true );
				m_lb->ensureCurrentVisible();
			}
		}
		break;

	  case Key_Enter :
	  case Key_Return :
		if (m_lb->item(m_lb->currentItem())) 
		{
			m_page->loadItemNReformat( m_lb->item( m_lb->currentItem() ));
		}
		break;
		
	  case Key_C :
		if (ke->state() == ControlButton) 
		{
			specialCopy();
		}
		else 
		{
			QString temp = text();
			QLineEdit::keyPressEvent( ke );
		
			if( temp != text())
			{
				m_page->textHasChanged();
			}
		};
		break;

	  case Key_Tab :
		m_page->tabWidget()->showPage( m_page->Voisin() );
		m_page->centralWidget()->pageSelected( m_page->Voisin() );
		break;

	  default:
		QString temp = text();
		QLineEdit::keyPressEvent( ke);
		
		if (temp != text())
		{
			m_page->textHasChanged();
		}
	}
}

void SearchField::focusInEvent ( QFocusEvent *fe )
{
	QLineEdit::focusInEvent( fe );
	if (!m_page->centralWidget()->built())
	{
		m_page->centralWidget()->setBuilt(true);
	}
	else
	{
		m_page->tengwarRender( m_page->searchField()->text() );
	}
}

void SearchField::specialCopy()
{
	if(hasMarkedText())
	{
		QLineEdit::copy();
	}
	else
	{
		m_page->centralWidget()->copy();
	}
}

/* EOF */
