/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
#ifndef SEARCHFIELD_H
#define SEARCHFIELD_H

#include <qlineedit.h>
#include <qwidget.h>
#include <qlistbox.h>

class Page;

class SearchField: public QLineEdit
{
	Q_OBJECT

	Page* m_page;
		
protected :
	
	QListBox* m_lb;
	virtual void keyPressEvent ( QKeyEvent *ke );
	virtual void focusInEvent ( QFocusEvent *fe );
	
	
public:
	void specialCopy ();
	void attributeListBox(QListBox* lb)
	{
		m_lb = lb;
	};

	SearchField(Page* page, QWidget * parent, const char * name=0 )
		:QLineEdit(parent, name)
	{
		m_page=page;
	};
	
	
};

#endif
