/*
 * Copyright (C) Dragon Flame, Benjamin Babut and Didier Willis
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
#include "sentenceline.h"

void SentenceLine::keyPressEvent( QKeyEvent *ke )
{
	QString temp = text();
	QLineEdit::keyPressEvent( ke );
	if (temp != text())
	{
		tengwarRender();
	}
}

void SentenceLine::focusInEvent( QFocusEvent *fe )
{
	QLineEdit::focusInEvent( fe );
	if (hasFocus())
	{
		tengwarRender();
	}
}

void SentenceLine::tengwarRender()
{
	QString toclean = text().latin1();

	toclean.replace( QRegExp(QChar(375)), "^y" );
	toclean.replace( QRegExp(QChar(339)), "e" );

	QString towrite;
	if (0 == m_cwidg->currentPage()->currentMode())
	{
		towrite = "<center><font face=\"Lucida Sans Unicode\" color=#660000>"+toclean+"</font></center>";
	}
	else
	{
		towrite = "<center><font color=#660000>"
			      + QString(m_cwidg->transcriptor(m_cwidg->currentPage()->currentMode()-1)->Roman2Tengwar(toclean))
				  + "</font></center>";
	}

	m_cwidg->tengView()->setText( towrite );
}

/* EOF */
